Bug 1308479 - Review Request: chck - Collection of C utilities
Review Request: chck - Collection of C utilities
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Denis Fateyev
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1308480
  Show dependency treegraph
 
Reported: 2016-02-15 05:34 EST by Fabio Alessandro Locati
Modified: 2016-04-17 23:19 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-04-13 17:34:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
denis: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Fabio Alessandro Locati 2016-02-15 05:34:33 EST
Spec URL: https://fale.fedorapeople.org/rpms/chck.spec
SRPM URL: https://fale.fedorapeople.org/rpms/chck-0-1.20160214git79d125f.fc23.src.rpm
Description: Collection of C utilities
Fedora Account System Username: fale
Comment 1 Denis Fateyev 2016-02-23 11:59:51 EST
1) One of the tests fails in multi-cpu env: 
  $ ctest -V -j4

test 12
      Start 12: thread_queue_test

12: Test command: /home/mock/sandbox/chck-79d125f14545560bd24bb437d87ee737f1ee16eb/test/thread_queue_test
12: Test timeout computed to be: 1500
test 2
      Start  2: pool_test

2: Test command: /home/mock/sandbox/chck-79d125f14545560bd24bb437d87ee737f1ee16eb/test/pool_test
2: Test timeout computed to be: 1500
12: thread_queue_test: /home/mock/sandbox/chck-79d125f14545560bd24bb437d87ee737f1ee16eb/chck/thread/queue/test.c:36: destructor: Assertion `(item->a == 1 && item->c == 2) || (item->a == 2 && item->c == 1)' failed.
 1/14 Test #12: thread_queue_test ................***Exception: Other  0.33 sec

2) You may request from upstream to prepare releases, it will be way more useful than the current versioning model.
Comment 2 Fabio Alessandro Locati 2016-02-23 13:05:02 EST
1. Thanks, I'll try to fix it/report upstream. I think it's a test problem and not a library problem.

2. I've already spoken with upstream and they don't have any intent to do releases soon.
Comment 3 Denis Fateyev 2016-02-23 13:38:47 EST
> I think it's a test problem and not a library problem.
It fails not every time, but each second / third invocation.
Tested also with 2 cpus, got the same faulty results.
Comment 4 Fabio Alessandro Locati 2016-04-06 12:15:37 EDT
Hello,

Sorry for the delay.

I've packed a new version:
SPEC: https://fale.fedorapeople.org/rpms/chck.spec
SRPM: https://fale.fedorapeople.org/rpms/chck-0-1.20160406git2efd6cd.fc23.src.rpm

I've tried to get a an "official" release from upstream, but they are still skeptical, but they have released 0.1 version for wlc and sway (the two packages that depend on this one), so I guess a release for chck will arrive at some point in future, but I would prefer not to wait it.

As for the test problem, I'm not able to reproduce it with the current version.
Comment 5 Denis Fateyev 2016-04-06 18:45:41 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "zlib/libpng". 53 files have unknown
     license. Detailed output of licensecheck in
     /home/mock/sandbox/review/1308479-chck/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/include/chck
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/include/chck
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in chck-
     debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: chck-0-1.20160406git2efd6cd.fc23.x86_64.rpm
          chck-devel-0-1.20160406git2efd6cd.fc23.x86_64.rpm
          chck-debuginfo-0-1.20160406git2efd6cd.fc23.x86_64.rpm
          chck-0-1.20160406git2efd6cd.fc23.src.rpm
chck.x86_64: W: incoherent-version-in-changelog 0.1.20160406git2efd6cd ['0-1.20160406git2efd6cd.fc23', '0-1.20160406git2efd6cd']
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-xdg.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-string.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-tqueue.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-atlas.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-buffer.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-sjis.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-pool.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-fs.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-lut.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-dl.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-unicode.so
chck-devel.x86_64: W: only-non-binary-in-usr-lib
chck-devel.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 14 warnings.


Rpmlint (debuginfo)
-------------------
Checking: chck-debuginfo-0-1.20160406git2efd6cd.fc23.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
chck-devel.x86_64: W: only-non-binary-in-usr-lib
chck-devel.x86_64: W: no-documentation
chck.x86_64: W: incoherent-version-in-changelog 0.1.20160406git2efd6cd ['0-1.20160406git2efd6cd.fc23', '0-1.20160406git2efd6cd']
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-fs.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-atlas.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-dl.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-tqueue.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-xdg.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-unicode.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-buffer.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-lut.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-pool.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-sjis.so
chck.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libchck-string.so
3 packages and 0 specfiles checked; 0 errors, 14 warnings.


Requires
--------
chck-debuginfo (rpmlib, GLIBC filtered):

chck-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    chck(x86-64)

chck (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libchck-atlas.so.0()(64bit)
    libchck-buffer.so.0()(64bit)
    libchck-dl.so.0()(64bit)
    libchck-fs.so.0()(64bit)
    libchck-lut.so.0()(64bit)
    libchck-pool.so.0()(64bit)
    libchck-sjis.so.0()(64bit)
    libchck-string.so.0()(64bit)
    libchck-tqueue.so.0()(64bit)
    libdl.so.2()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)


Provides
--------
chck-debuginfo:
    chck-debuginfo
    chck-debuginfo(x86-64)

chck-devel:
    chck-devel
    chck-devel(x86-64)
    pkgconfig(chck)

chck:
    chck
    chck(x86-64)
    libchck-atlas.so.0()(64bit)
    libchck-buffer.so.0()(64bit)
    libchck-dl.so.0()(64bit)
    libchck-fs.so.0()(64bit)
    libchck-lut.so.0()(64bit)
    libchck-pool.so.0()(64bit)
    libchck-sjis.so.0()(64bit)
    libchck-string.so.0()(64bit)
    libchck-tqueue.so.0()(64bit)
    libchck-unicode.so.0()(64bit)
    libchck-xdg.so.0()(64bit)


Unversioned so-files
--------------------
chck: /usr/lib64/libchck-atlas.so
chck: /usr/lib64/libchck-buffer.so
chck: /usr/lib64/libchck-dl.so
chck: /usr/lib64/libchck-fs.so
chck: /usr/lib64/libchck-lut.so
chck: /usr/lib64/libchck-pool.so
chck: /usr/lib64/libchck-sjis.so
chck: /usr/lib64/libchck-string.so
chck: /usr/lib64/libchck-tqueue.so
chck: /usr/lib64/libchck-unicode.so
chck: /usr/lib64/libchck-xdg.so

Source checksums
----------------
https://github.com/Cloudef/chck/archive/2efd6cd314884712e9409e54c302afb9b9fff1b0.tar.gz#/chck-2efd6cd.tar.gz :
  CHECKSUM(SHA256) this package     : f7b0e6e764e74fe00fcf1f9e8e770234b25d3afd444f6b56d7376d3829ed01fc
  CHECKSUM(SHA256) upstream package : f7b0e6e764e74fe00fcf1f9e8e770234b25d3afd444f6b56d7376d3829ed01fc


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1308479
Buildroot used: fedora-23-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Remarks:
-------
1) Please place unversioned .so-files into '-devel' subpackage;
2) Add "BR: make" as requested by policy (there's no BR exclude list anymore);
3) Your package needs to own `%{_includedir}/chck`.
Comment 6 Fabio Alessandro Locati 2016-04-07 04:39:06 EDT
1. Aren't we in the "When a shared library file is only provided in an unversioned format, the packager should ask upstream to consider providing a properly versioned library file. However, in such cases, if the shared library file is necessary for users to run programs linked against it, it must go into the base package." case?

2. Sorry, I don't understand what are you referring to. Can you please link me the policy where that "BR: make" is explained?

3. Thanks, I've just fixed it.

SPEC: https://fale.fedorapeople.org/rpms/chck.spec
SRPM: https://fale.fedorapeople.org/rpms/chck-0-1.20160407git2efd6cd.fc23.src.rpm
Comment 7 Denis Fateyev 2016-04-07 09:31:38 EDT
(In reply to Fabio Alessandro Locati from comment #6)
> 1. Aren't we in the "When a shared library file is only provided in an
> unversioned format, the packager should ask upstream to consider providing a
> properly versioned library file. However, in such cases, if the shared
> library file is necessary for users to run programs linked against it, it
> must go into the base package." case?

No. The package already provides versioned libraries (which is the proper behavior), so it's not the case. Programs will be correctly linked against versioned libraries, so everything we need is to move unversioned links to `-devel` subpackage.

> 2. Sorry, I don't understand what are you referring to. Can you please link
> me the policy where that "BR: make" is explained?

For example, https://fedorahosted.org/fpc/ticket/497#comment:21
which leads to the current policy on BRs (https://fedoraproject.org/wiki/Packaging:Guidelines#BuildRequires_2), and the diff between two revisions.
Comment 8 Denis Fateyev 2016-04-07 09:38:43 EDT
(In reply to Fabio Alessandro Locati from comment #6)
> 3. Thanks, I've just fixed it.

One line
  %{_includedir}/chck/

instead of two lines
  %dir %{_includedir}/chck
  %{_includedir}/chck/*

will be easier.. dir name will be detected and processed automagically.
Comment 9 Fabio Alessandro Locati 2016-04-08 05:00:34 EDT
1. Thanks for the clarification :)

2. Oh, ok. Sorry, I did not recognized that "BR" was meaning "BuildRequires"

3. Nice :) thanks

Updated the package:

SPEC: https://fale.fedorapeople.org/rpms/chck.spec
SRPM: https://fale.fedorapeople.org/rpms/chck-0-1.20160408git2efd6cd.fc23.src.rpm
Comment 10 Denis Fateyev 2016-04-08 08:40:49 EDT
Koji rawhide scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=13595904

Better to avoid macroses in changelog:
chck.src:56: W: macro-in-%changelog %{_includedir}
chck.src:60: W: macro-in-%changelog %{_includedir}

Otherwise the package is APPROVED.
Comment 11 Fabio Alessandro Locati 2016-04-08 12:03:26 EDT
Thanks :)
Comment 12 Gwyn Ciesla 2016-04-08 16:03:43 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/chck
Comment 13 Fedora Update System 2016-04-08 17:41:19 EDT
chck-0-1.20160408git2efd6cd.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ba396be891
Comment 14 Fedora Update System 2016-04-08 17:41:26 EDT
chck-0-1.20160408git2efd6cd.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-5fb85e8fcb
Comment 15 Fedora Update System 2016-04-09 14:51:51 EDT
chck-0-1.20160408git2efd6cd.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-5fb85e8fcb
Comment 16 Fedora Update System 2016-04-09 15:23:49 EDT
chck-0-1.20160408git2efd6cd.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ba396be891
Comment 17 Fedora Update System 2016-04-13 17:34:16 EDT
chck-0-1.20160408git2efd6cd.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 18 Fedora Update System 2016-04-17 23:19:56 EDT
chck-0-1.20160408git2efd6cd.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.